﻿using UnityEngine;
using System.Collections;

public class BG_Manager : MonoBehaviour
{
	private static BG_Manager m_instance;

	public BackGround[] BGMats;
	public GameObject[] BG_Obj;

	private int NumofBG;

	//For Visualize and Debug
	[Range (0.0f, 1.0f)]
	public float Saturation;

	public static void SetSaturation(float input)
	{
		m_instance.Saturation = input;
		int NumofBG = m_instance.BGMats.Length;
		for (int i=0; i<NumofBG; i++)
		{
			m_instance.BGMats [i].SetSaturation (input);
		}
	}

	// Use this for initialization
	void Awake ()
	{
		m_instance = this;

		Saturation = 1.0f;

		BGMats = GetComponentsInChildren<BackGround> ();

		BG_Obj = new GameObject[BGMats.Length];

		NumofBG = BGMats.Length;

		for (int i = 0; i<NumofBG;i++)
		{
			BG_Obj [i] = BGMats [i].gameObject;
		}

		BG_Manager.ChangeBGbyNowTime ();
	}
	
	// Update is called once per frame
	void Update ()
	{
		//For Testing
//		for (int i=0; i<NumofBG; i++)
//		{
//			BGMats [i].SetSaturation (Saturation);
//		}
	}


	//Plz call after change schedule
	public static void ChangeBGbyNowTime()
	{
		for (int i = 0; i<m_instance.NumofBG; i++)
		{
			//BackGround On/Off
			if (GameManager.GetEventTime ()._schedule.Equals (m_instance.BGMats [i].ScheduleOrder))
			{
				m_instance.BG_Obj [i].SetActive (true);
				//Environment's on/off
				if (m_instance.BGMats [i].isIndoor)
				{
					//Environment Sound on, Visual off
				}
				else
				{
					//Environment Sound on, Visual on
				}
			}
			else
			{
				m_instance.BG_Obj [i].SetActive (false);
			}
		}
	}
}
