﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class CsButton : MonoBehaviour {

	public bool isRingingRun = true;

	public static CsButton S;

	public string A;
	public string B;
	public string Title;

	public CsButtonAB ButtonA;
	public CsButtonAB ButtonB;

	public TextMesh textA;
	public TextMesh textB;
	public TextMesh title;

	public float fadeInTime;
	public float fadeOutTime;
	public bool isFadeIO;

	private int count;

	void Awake()
	{
		S = this;
		count = 0;
	}

	void Update(){
		Color color = title.color;

		if (isFadeIO) {
			color.a += 1f / fadeInTime * Time.deltaTime;

			if (color.a > 1f) {
				color.a = 1f;
			}
		} else {
			color.a -= 1f / fadeOutTime * Time.deltaTime;

			if (color.a < 0f) {
				color.a = 0f;
			}
		}

		textA.color = textB.color = title.color = color;
	}

	void OnEnable()
	{
		SetChooseSelection ();
		ButtonA.check.enabled = false;
		ButtonB.check.enabled = false;
		isFadeIO = true;
	}


	void Disappear()
	{
		if (count == 0) {
			Ringing ();
			count++;
		} else {
			Invoke ("GotoNext", 2f);
		}
		gameObject.SetActive (false);
	}

	public void SetChooseSelection()
	{
		textA.text = A;
		textB.text = B;
		title.text = Title;
	}

	public void RunButtonA()
	{
		if (isRingingRun) {
			if (count == 0)
				Char_Manager.Emotion_Change (1);
			else
				Char_Manager.Emotion_Change (-1);
		} else {
			Char_Manager.Emotion_Change (0);
		}

		Invoke ("Disappear", 0.8f);
		ButtonA.check.enabled = true;
		isFadeIO = false;

		if (!isRingingRun)
			return;
		
		//action
		CsFadeIO.S.fadeDelayTime = 1f;
	}

	public void RunButtonB()
	{
		Char_Manager.Emotion_Change (0);

		Invoke ("Disappear", 0.8f);
		ButtonB.check.enabled = true;
		isFadeIO = false;

		if (!isRingingRun)
			return;
		
		//action
		CsFadeIO.S.fadeDelayTime = 1f;
	}


	void Ringing(){
		if (isRingingRun)
			CsWeekManager.S.Ringing ();
		else
			Invoke ("GotoFinish", 2f);
	}

	void GotoNext()
	{
		Application.LoadLevel ("Play2");
	}

	void GotoFinish()
	{
		Application.LoadLevel ("End");
	}
}