﻿using UnityEngine;
using System.Collections;

public class CsFadeIO : MonoBehaviour {

	public static CsFadeIO S;

	public SpriteRenderer sprite;

	[Range(0f,1f)]
	public float fadeA;

	public float fadeInTime;
	public float fadeOutTime;

	public float fadeDelayTime;
	public bool isFadeIO;


	void Awake () {
		S = this;
	}

	void Update(){
		Color color = sprite.color;

		if (isFadeIO) {
			color.a += 1f / fadeInTime * Time.deltaTime;

			if (color.a > fadeA) {
				color.a = fadeA;
				Invoke("EndFadeIO", fadeDelayTime);
			}
		} else {
			color.a -= 1f / fadeOutTime * Time.deltaTime;
			if (color.a < 0f)
				color.a = 0f;
		}

		sprite.color = color;

	}
		
	public void StartFadeIO(){
		isFadeIO = true;
	}

	void EndFadeIO(){
		isFadeIO = false;
	}
}