﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;

public class CsTextPrinter : MonoBehaviour {

	public static CsTextPrinter S;

	public float appearTime;
	public float disappearTime;


	public float appearDelay;
	public float gap;

	public bool ________________________;

	public string[] outputText;

	public bool[] showText;

	public GameObject[] outputLines;

	public List<Image> BackPanel;

	private int count;

	void Awake()
	{
		S = this;

		//TextBack.SetActive (false);
	}

	void Update(){
		SetTextes ();




		Color tmpColor;

		for (int i = 0; i < 10; i++) {
			tmpColor = outputLines [i].GetComponent<Text> ().color;

			if (showText [i] == true) {
				tmpColor.a += 1f/appearTime * Time.deltaTime;

				if (tmpColor.a >= 1f)
					showText [i] = false;
			} else {
				tmpColor.a -= 1f/disappearTime * Time.deltaTime;

				if (tmpColor.a < 0f) {
					tmpColor.a = 0f;
					//TextBack.SetActive (false);
				}
			}

			outputLines [i].GetComponent<Text> ().color = tmpColor;

			tmpColor = BackPanel [i].color;

			if (showText [i] == true) {
				tmpColor.a += 0.5f/appearTime * Time.deltaTime;

				//if (tmpColor.a >= 0.3f)
					//showText [i] = false;
			} else {
				tmpColor.a -= 1f/disappearTime * Time.deltaTime;

				if (tmpColor.a < 0f) {
					tmpColor.a = 0f;
					//TextBack.SetActive (false);
				}
			}

			BackPanel [i].color = tmpColor;
		}
	}



	void SetTextes()
	{
		Text[] texts = GetComponentsInChildren<Text> ();

		for (int i = 0; i < outputText.Length; i++) {
			texts [i].text = outputText[i];
		}	
	}


	public void ShowText(int line)
	{
		showText [line] = true;
	}


	void _ShowAllTextes()
	{
		showText [count] = true;
		count++;

		while (true) {
			if (count >= 10) {
				CancelInvoke ();
				break;
			}
			
			if (outputText [count] == "")
				count++;
			else
				break;
		}

		if (count >= 10)
			CancelInvoke ();
	}

	public void ShowAllTextes()
	{
		count = 0;
		InvokeRepeating ("_ShowAllTextes", 0f, appearDelay);
	}


	public void SigleShowText(int lineNumber, string str)
	{
		CsTextPrinter.S.outputText [lineNumber] = str;
		CsTextPrinter.S.showText [lineNumber] = true;
	}





	[ContextMenu("ShowLines")]
	public void ShowLines()
	{
		Color color = new Color (1, 1, 1, 1);

		foreach (var line in outputLines) {
			line.GetComponent<Text> ().color = color;
		}
	}

	[ContextMenu("UnshowLines")]
	public void UnshowLines()
	{
		Color color = new Color (1, 1, 1, 0);

		foreach (var line in outputLines) {
			line.GetComponent<Text> ().color = color;
		}
	}


	[ContextMenu("SetLines")]
	public void SetLines()
	{
		float i = 4.5f;

		foreach (var line in outputLines) {
			line.GetComponent<RectTransform> ().localPosition = new Vector3(0f, i * gap, 0f);

			i -= 1f;
		}
	}
}
