﻿using UnityEngine;
using System.Collections;


public class emotionArray : MonoBehaviour
{

    public GameObject[] EmotionIcons;

    public SpriteRenderer[] IconsRender;
    public GameObject frame;
    private SpriteRenderer frameRenderer;
    private Color framecolor;


    private Color _color;

    private Vector3 pos;
    private Vector3 NextPos;

    private int MoveDist;

    public int Init_Emotion;

    public bool bFadeIn;
    public bool bMove;
    public bool bFadeOut;



	void OnLevelWasLoaded()
	{
		print ("rrr");
		frame = GameObject.Find ("frame");
		frameRenderer = frame.GetComponent<SpriteRenderer>();
	}

    void Awake()
    {
		DontDestroyOnLoad (gameObject);
		frameRenderer = frame.GetComponent<SpriteRenderer>();
        IconsRender = new SpriteRenderer[10];
        
        for (int i = 0; i < 10; i++)
        {
            IconsRender[i] = EmotionIcons[i].GetComponent<SpriteRenderer>();

            pos = EmotionIcons[i].transform.position;
            pos.x = i * 2.0f;
            EmotionIcons[i].transform.position = pos;

            _color = IconsRender[i].color;
            _color.a = 0.0f;
            IconsRender[i].color = _color;
        }

        _color = frameRenderer.color;
        _color.a = 0.0f;
        frameRenderer.color = _color;


        pos = transform.position;
        pos.x -= (Init_Emotion - 1) * 2.0f;
        transform.position = pos;
    }

    public void EmotionChange(int num)
    {
        bFadeIn = true;
        MoveDist = num;
        StartCoroutine(FadeInExit());
    }

    void Update()
    {
        if (Input.GetKeyDown(KeyCode.Q))
        {
            EmotionChange(-2);
        }
        if (Input.GetKeyDown(KeyCode.W))
        {
            EmotionChange(-1);
        }
        if (Input.GetKeyDown(KeyCode.E))
        {
            EmotionChange(1);
        }
        if (Input.GetKeyDown(KeyCode.R))
        {
            EmotionChange(2);
        }

        if (bFadeIn)
        {
            for (int i = 0; i < 10; i++)
            {
                _color = IconsRender[i].color;
                _color.a += 2.0f * Time.deltaTime;
                if (_color.a > 1.0f)
                    _color.a = 1.0f;
                IconsRender[i].color = _color;
            }
            _color = frameRenderer.color;
            _color.a += 2.0f * Time.deltaTime;
            if (_color.a > 1.0f)
                _color.a = 1.0f;
            frameRenderer.color = _color;
        }

        if (bMove)
        {
            pos = transform.position;
            pos.x -= 2.0f * Time.deltaTime * MoveDist;
            transform.position = pos;
        }

        if (bFadeOut)
        {
            for (int i = 0; i < 10; i++)
            {
                _color = IconsRender[i].color;
                _color.a -= 2.0f * Time.deltaTime ;
                if (_color.a < 0.0f)
                    _color.a = 0.0f;
                IconsRender[i].color = _color;
            }
            _color = frameRenderer.color;
            _color.a -= 2.0f * Time.deltaTime;
            if (_color.a < 0.0f)
                _color.a = 0.0f;
            frameRenderer.color = _color;
        }
    }

    IEnumerator FadeInExit()
    {
        yield return new WaitForSeconds(0.5f);

        bFadeIn = false;
        bMove = true;

        for (int i = 0; i < 10; i++)
        {
            _color = IconsRender[i].color;
            _color.a = 1.0f;
            IconsRender[i].color = _color;
        }

        //위치저장
        NextPos = transform.position;
        NextPos.x -= 2.0f * MoveDist;

        yield return new WaitForSeconds(1.0f);
        bMove = false;
        bFadeOut = true;

        transform.position = NextPos;

        yield return new WaitForSeconds(0.5f);

        for (int i = 0; i < 10; i++)
        {
            _color = IconsRender[i].color;

            _color.a = 0.0f;
            IconsRender[i].color = _color;
        }

        bFadeOut = false;

    }
};



