﻿using UnityEngine;
using System.Collections;

public class handMover : MonoBehaviour
{
	public AudioSource oneFoot;
	public AudioSource flowerpotBreak;

    public GameObject[] backgrounds;
    private int backGroundCount = 0;
    public GameObject[] hands;
    private Vector3 vec3;
    private Color _color;
    SpriteRenderer[] handsRenderer;
    private Camera _camera;
    public GameObject flowerPot;

    public GameObject blackBack;
    public GameObject breakedPot;

    private SpriteRenderer blackBackRend;
    private SpriteRenderer breakedPotRend;

    public bool bForward;
    public bool bCatch;
    public bool bBack;
    public bool bScale;
    public bool bBlack;
    public bool bDead;

	public bool isCameraShaking;
	public float shakingTime;
	public float shakingSize;

	public bool isSmalling;
	public float smallingTime;

	private Vector3 cameraPos;
	private bool isClicked;



    void handsMoveOn()
    {
        bForward = true;
        StartCoroutine(FadeInExit());
    }

    // Use this for initialization
    void Awake()
    {
		cameraPos = Camera.main.transform.position;

        handsRenderer = GetComponentsInChildren<SpriteRenderer>();
        blackBackRend = blackBack.GetComponent<SpriteRenderer>();
        breakedPotRend = breakedPot.GetComponent<SpriteRenderer>();

        _color = blackBackRend.color;
        _color.a = 0.0f;
        blackBackRend.color = _color;

        _color = breakedPotRend.color;
        _color.a = 0.0f;
        breakedPotRend.color = _color;

        for (int i = 0; i < 2; ++i)
        {
            vec3 = hands[i].transform.position;
            vec3.x += 3 * Mathf.Pow(-1, i);
            hands[i].transform.position = vec3;
        }
        vec3 = transform.position;
        vec3.y -= Camera.main.orthographicSize;
        transform.position = vec3;
    }

    // Update is called once per frame
    void Update()
    {
		if (Input.GetMouseButtonDown(0) && !isClicked)
        {
            handsMoveOn();
			isClicked = true;
        }

        if (bForward)
        {
            vec3 = transform.position;
            vec3.y += 3.0f * Time.deltaTime;
            transform.position = vec3;
        }

        if (bCatch)
        {
            for (int i = 0; i < 2; ++i)
            {
                vec3 = hands[i].transform.position;
                vec3.x += 1.0f * Mathf.Pow(-1, i+1) * Time.deltaTime;
                hands[i].transform.position = vec3;
            }
        }

        if (bBack)
        {
            vec3 = transform.position;
            vec3.y -= 4.5f * Time.deltaTime;
            transform.position = vec3;

            vec3 = flowerPot.transform.position;
            vec3.y -= 4.5f * Time.deltaTime;
            flowerPot.transform.position= vec3;
           
        }
        if(bScale)
        {
            Vector3 scale = new Vector3(2.6f, 2.6f, 1.0f);
            backgrounds[1].transform.localScale = Vector3.Lerp(backgrounds[1].transform.localScale, scale, Time.deltaTime);
        }
        if (bBlack)
        {
            _color = blackBackRend.color;
            _color.a += 1.0f * Time.deltaTime;
            if (_color.a > 1.0f)
                _color.a = 1.0f;
            blackBackRend.color = _color;
           
        }
        if (bDead)
        {
            _color = breakedPotRend.color;
            _color.a += .5f * Time.deltaTime;
            if (_color.a > 1.0f)
                _color.a = 1.0f;
            breakedPotRend.color = _color;

        }

		if (isCameraShaking) {
			Camera.main.transform.position = cameraPos + new Vector3(Random.value, Random.value, Random.value) * shakingSize;

			shakingSize -= shakingSize / shakingTime * Time.deltaTime;

			Invoke ("ShakingEnd", shakingTime);
			Invoke ("FadeIn", shakingTime+3f);
		}

		if (isSmalling) {
			float scale = breakedPot.transform.localScale.x;
			scale -= 1f/smallingTime * Time.deltaTime * 5f;

			if (scale < 0f)
				scale = 0f;

			breakedPot.transform.localScale = new Vector3 (scale, scale, scale);
		}
    }

	void ShakingEnd(){
		Camera.main.transform.position = cameraPos;
		isCameraShaking = false;
	}

	void FadeIn(){
		CsFadeIO.S.StartFadeIO ();
		isSmalling = true;

		Invoke ("GotoFinish", 2f);
	}

	void GotoFinish(){
		Application.LoadLevel ("Credit");
	}


	void OneFootPlay()
	{
		oneFoot.Play ();
	}

    IEnumerator FadeInExit()
    {
        yield return new WaitForSeconds(1.0f);
        bForward = false;
        bCatch = true;
        yield return new WaitForSeconds(1.0f);
        bCatch = false;
        bBack = true;
        yield return new WaitForSeconds(0.5f);
        bBack = false;
        yield return new WaitForSeconds(0.5f);
        vec3 = backgrounds[backGroundCount].transform.position;
        vec3.z = -100;
        backgrounds[backGroundCount++].transform.position = vec3 ;



        yield return new WaitForSeconds(0.3f);
        bScale = true;
        Quaternion tempRotation = backgrounds[backGroundCount].transform.rotation;
        vec3 =tempRotation.eulerAngles;
        vec3.z = 3.0f;
        tempRotation.eulerAngles = vec3;
        backgrounds[backGroundCount].transform.rotation = tempRotation;
		OneFootPlay ();

        yield return new WaitForSeconds(0.3f);
        bScale = false;



        yield return new WaitForSeconds(0.3f);
        bScale = true;
        tempRotation = backgrounds[backGroundCount].transform.rotation;
        vec3 = tempRotation.eulerAngles;
        vec3.z = -3.0f;
        tempRotation.eulerAngles = vec3;
        backgrounds[backGroundCount].transform.rotation = tempRotation;
		OneFootPlay ();

        yield return new WaitForSeconds(0.3f);
        bScale = false;


        yield return new WaitForSeconds(0.3f);
        bScale = true;
        tempRotation = backgrounds[backGroundCount].transform.rotation;
        vec3 = tempRotation.eulerAngles;
        vec3.z = 3.0f;
        tempRotation.eulerAngles = vec3;
        backgrounds[backGroundCount].transform.rotation = tempRotation;
		OneFootPlay ();


        yield return new WaitForSeconds(0.3f);
        bScale = false;
        yield return new WaitForSeconds(0.3f);
        bScale = true;
        tempRotation = backgrounds[backGroundCount].transform.rotation;
        vec3 = tempRotation.eulerAngles;
        vec3.z = -3.0f;
        tempRotation.eulerAngles = vec3;
        backgrounds[backGroundCount].transform.rotation = tempRotation;
		OneFootPlay ();

         yield return new WaitForSeconds(0.3f);
        bScale = false;
        yield return new WaitForSeconds(0.5f);
        vec3 = backgrounds[backGroundCount].transform.position;
        vec3.z = -100;
        backgrounds[backGroundCount++].transform.position = vec3;
        yield return new WaitForSeconds(0.5f);
        vec3 = transform.position;
        vec3.z = 100;
        transform.position = vec3;
        flowerPot.transform.position = vec3;
        bBlack = true;
        yield return new WaitForSeconds(3.0f);
        bBlack = false;
        bDead = true;
		isCameraShaking = true;
		flowerpotBreak.Play ();
    }
}